ctdb-scripts: Add default for public addresses file where missing
[gd/samba-autobuild/.git] / ctdb / config / functions
1 # Hey Emacs, this is a -*- shell-script -*- !!!
2
3 # utility functions for ctdb event scripts
4
5 if [ -z "$CTDB_BASE" ] ; then
6     echo 'CTDB_BASE unset in CTDB functions file'
7     exit 1
8 fi
9 export CTDB_BASE
10
11 # CTDB_VARDIR is used elsewhere
12 # shellcheck disable=SC2034
13 CTDB_VARDIR="/usr/local/var/lib/ctdb"
14 ctdb_rundir="/usr/local/var/run/ctdb"
15
16 CTDB="${CTDB:-/usr/local/bin/ctdb}"
17
18 # Only (and always) override these variables in test code
19
20 if [ -z "$CTDB_SCRIPT_VARDIR" ] ; then
21     CTDB_SCRIPT_VARDIR="/usr/local/var/lib/ctdb/state"
22 fi
23
24 if [ -z "$CTDB_SYS_ETCDIR" ] ; then
25     CTDB_SYS_ETCDIR="/etc"
26 fi
27
28 if [ -z "$CTDB_HELPER_BINDIR" ] ; then
29     CTDB_HELPER_BINDIR="/usr/local/libexec/ctdb"
30 fi
31
32 #######################################
33 # pull in a system config file, if any
34
35 rewrite_ctdb_options ()
36 {
37     case "$CTDB_DBDIR" in
38         tmpfs|tmpfs:*)
39             _opts_defaults="mode=700"
40             # Get any extra options specified after colon
41             if [ "$CTDB_DBDIR" = "tmpfs" ] ; then
42                 _opts=""
43             else
44                 _opts="${CTDB_DBDIR#tmpfs:}"
45             fi
46             # It is OK to repeat mount options - last value wins.
47             # CTDB_DBDIR_TMPFS_OPTIONS is used by ctdbd_wrapper
48             # shellcheck disable=SC2034
49             CTDB_DBDIR_TMPFS_OPTIONS="${_opts_defaults}${_opts:+,}${_opts}"
50
51             CTDB_DBDIR="${ctdb_rundir}/CTDB_DBDIR"
52             ;;
53         *)
54             # shellcheck disable=SC2034
55             CTDB_DBDIR_TMPFS_OPTIONS=""
56     esac
57 }
58
59 _loadconfig() {
60
61     if [ -z "$1" ] ; then
62         foo="${service_config:-${service_name}}"
63         if [ -n "$foo" ] ; then
64             loadconfig "$foo"
65             return
66         fi
67     fi
68
69     if [ "$1" != "ctdb" ] ; then
70         loadconfig "ctdb"
71     fi
72
73     if [ -z "$1" ] ; then
74         return
75     fi
76
77     if [ -f "${CTDB_SYS_ETCDIR}/sysconfig/$1" ]; then
78         . "${CTDB_SYS_ETCDIR}/sysconfig/$1"
79     elif [ -f "${CTDB_SYS_ETCDIR}/default/$1" ]; then
80         . "${CTDB_SYS_ETCDIR}/default/$1"
81     elif [ -f "${CTDB_BASE}/sysconfig/$1" ]; then
82         . "${CTDB_BASE}/sysconfig/$1"
83     fi
84
85     if [ "$1" = "ctdb" ] ; then
86         _config="${CTDBD_CONF:-${CTDB_BASE}/ctdbd.conf}"
87         if [ -r "$_config" ] ; then
88             . "$_config"
89         fi
90         rewrite_ctdb_options
91     fi
92 }
93
94 loadconfig () {
95     _loadconfig "$@"
96 }
97
98 ##############################################################
99
100 die ()
101 {
102     _msg="$1"
103     _rc="${2:-1}"
104
105     echo "$_msg" >&2
106     exit "$_rc"
107 }
108
109 # Log given message or stdin to either syslog or a CTDB log file
110 # $1 is the tag passed to logger if syslog is in use.
111 script_log ()
112 {
113     _tag="$1" ; shift
114
115     case "$CTDB_LOGGING" in
116         file:*|"")
117             if [ -n "$CTDB_LOGGING" ] ; then
118                 _file="${CTDB_LOGGING#file:}"
119             else
120                 _file="/usr/local/var/log/log.ctdb"
121             fi
122             {
123                 if [ -n "$*" ] ; then
124                     echo "$*"
125                 else
126                     cat
127                 fi
128             } >>"$_file"
129             ;;
130         *)
131             # Handle all syslog:* variants here too.  There's no tool to do
132             # the lossy things, so just use logger.
133             logger -t "ctdbd: ${_tag}" "$@"
134             ;;
135     esac
136 }
137
138 # When things are run in the background in an eventscript then logging
139 # output might get lost.  This is the "solution".  :-)
140 background_with_logging ()
141 {
142     (
143         "$@" 2>&1 </dev/null |
144         script_log "${script_name}&"
145     )&
146
147     return 0
148 }
149
150 ##############################################################
151 # check number of args for different events
152 ctdb_check_args ()
153 {
154     case "$1" in
155         takeip|releaseip)
156             if [ $# != 4 ]; then
157                 echo "ERROR: must supply interface, IP and maskbits"
158                 exit 1
159             fi
160             ;;
161         updateip)
162             if [ $# != 5 ]; then
163                 echo "ERROR: must supply old interface, new interface, IP and maskbits"
164                 exit 1
165             fi
166             ;;
167     esac
168 }
169
170 ##############################################################
171 # determine on what type of system (init style) we are running
172 detect_init_style()
173 {
174     # only do detection if not already set:
175     [ -z "$CTDB_INIT_STYLE" ] || return
176
177     if [ -x /sbin/startproc ]; then
178         CTDB_INIT_STYLE="suse"
179     elif [ -x /sbin/start-stop-daemon ]; then
180         CTDB_INIT_STYLE="debian"
181     else
182         CTDB_INIT_STYLE="redhat"
183     fi
184 }
185
186 ######################################################
187 # simulate /sbin/service on platforms that don't have it
188 # _service() makes it easier to hook the service() function for
189 # testing.
190 _service ()
191 {
192   _service_name="$1"
193   _op="$2"
194
195   # do nothing, when no service was specified
196   [ -z "$_service_name" ] && return
197
198   if [ -x /sbin/service ]; then
199       $_nice /sbin/service "$_service_name" "$_op"
200   elif [ -x /usr/sbin/service ]; then
201       $_nice /usr/sbin/service "$_service_name" "$_op"
202   elif [ -x /bin/systemctl ]; then
203       $_nice /bin/systemctl "$_op" "$_service_name"
204   elif [ -x "${CTDB_SYS_ETCDIR}/init.d/${_service_name}" ]; then
205       $_nice "${CTDB_SYS_ETCDIR}/init.d/${_service_name}" "$_op"
206   elif [ -x "${CTDB_SYS_ETCDIR}/rc.d/init.d/${_service_name}" ]; then
207       $_nice "${CTDB_SYS_ETCDIR}/rc.d/init.d/${_service_name}" "$_op"
208   fi
209 }
210
211 service()
212 {
213     _nice=""
214     _service "$@"
215 }
216
217 ######################################################
218 # simulate /sbin/service (niced) on platforms that don't have it
219 nice_service()
220 {
221     _nice="nice"
222     _service "$@"
223 }
224
225 ######################################################
226 # Cached retrieval of PNN from local node.  This never changes so why
227 # open a client connection to the server each time this is needed?
228 ctdb_get_pnn ()
229 {
230     _pnn_file="${CTDB_SCRIPT_VARDIR}/my-pnn"
231     if [ ! -f "$_pnn_file" ] ; then
232         $CTDB pnn >"$_pnn_file"
233     fi
234
235     cat "$_pnn_file"
236 }
237
238 # Cached retrieval of private IP address from local node.  This never
239 # changes.
240 ctdb_get_ip_address ()
241 {
242     _ip_addr_file="${CTDB_SCRIPT_VARDIR}/my-ip-address"
243     if [ ! -f "$_ip_addr_file" ] ; then
244         $CTDB -X nodestatus |
245             awk -F '|' 'NR == 2 { print $3 }' >"$_ip_addr_file"
246     fi
247
248     # ip_address is used by caller
249     # shellcheck disable=SC2034
250     cat "$_ip_addr_file"
251 }
252
253 ######################################################
254 # wrapper around /proc/ settings to allow them to be hooked
255 # for testing
256 # 1st arg is relative path under /proc/, 2nd arg is value to set
257 set_proc ()
258 {
259     echo "$2" >"/proc/$1"
260 }
261
262 set_proc_maybe ()
263 {
264     if [ -w "/proc/$1" ] ; then
265         set_proc "$1" "$2"
266     fi
267 }
268
269 ######################################################
270 # wrapper around getting file contents from /proc/ to allow
271 # this to be hooked for testing
272 # 1st arg is relative path under /proc/
273 get_proc ()
274 {
275     cat "/proc/$1"
276 }
277
278 ######################################################
279 # Print up to $_max kernel stack traces for processes named $_program
280 program_stack_traces ()
281 {
282     _prog="$1"
283     _max="${2:-1}"
284
285     _count=1
286     for _pid in $(pidof "$_prog") ; do
287         [ "$_count" -le "$_max" ] || break
288
289         # Do this first to avoid racing with process exit
290         _stack=$(get_proc "${_pid}/stack" 2>/dev/null)
291         if [ -n "$_stack" ] ; then
292             echo "Stack trace for ${_prog}[${_pid}]:"
293             echo "$_stack"
294             _count=$((_count + 1))
295         fi
296     done
297 }
298
299 ######################################################
300 # Ensure $service_name is set
301 assert_service_name ()
302 {
303     [ -n "$service_name" ] || die "INTERNAL ERROR: \$service_name not set"
304 }
305
306 ######################################################
307 # check a set of directories is available
308 # return 1 on a missing directory
309 # directories are read from stdin
310 ######################################################
311 ctdb_check_directories_probe()
312 {
313     while IFS="" read d ; do
314         case "$d" in
315             *%*)
316                 continue
317                 ;;
318             *)
319                 [ -d "${d}/." ] || return 1
320         esac
321     done
322 }
323
324 ######################################################
325 # check a set of directories is available
326 # directories are read from stdin
327 ######################################################
328 ctdb_check_directories()
329 {
330     ctdb_check_directories_probe || {
331         echo "ERROR: $service_name directory \"$d\" not available"
332         exit 1
333     }
334 }
335
336 ######################################################
337 # check a set of tcp ports
338 # usage: ctdb_check_tcp_ports <ports...>
339 ######################################################
340
341 # Check whether something is listening on all of the given TCP ports
342 # using the "ctdb checktcpport" command.
343 ctdb_check_tcp_ports()
344 {
345         if [ -z "$1" ] ; then
346                 echo "INTERNAL ERROR: ctdb_check_tcp_ports - no ports specified"
347                 exit 1
348         fi
349
350         for _p ; do  # process each function argument (port)
351                 _cmd="$CTDB checktcpport $_p"
352                 _out=$($_cmd 2>&1)
353                 _ret=$?
354                 case "$_ret" in
355                 0)
356                         echo "$service_name not listening on TCP port $_p"
357                         return 1
358                         ;;
359                 98)
360                         # Couldn't bind, something already listening, next port
361                         continue
362                         ;;
363                 *)
364                         echo "unexpected error (${_ret}) running \"${_cmd}\""
365                         if [ -n "$_out" ] ; then
366                                 echo "$_out"
367                         fi
368                         return $_ret
369                         ;;
370                 esac
371         done
372
373         # All ports listening
374         return 0
375 }
376
377 ######################################################
378 # check a unix socket
379 # usage: ctdb_check_unix_socket SOCKPATH
380 ######################################################
381 ctdb_check_unix_socket()
382 {
383         _sockpath="$1"
384
385         if [ -z "$_sockpath" ] ; then
386                 echo "ERROR: ctdb_check_unix_socket() requires socket path"
387                 return 1
388         fi
389
390         _out=$(ss -l -x "src ${_sockpath}" | tail -n +2)
391         if [ -z "$_out" ] ; then
392                 echo "ERROR: ${service_name} not listening on ${_sockpath}"
393                 return 1
394         fi
395 }
396
397 ################################################
398 # kill off any TCP connections with the given IP
399 ################################################
400 kill_tcp_connections ()
401 {
402     _iface="$1"
403     _ip="$2"
404
405     _oneway=false
406     if [ "$3" = "oneway" ] ; then
407         _oneway=true
408     fi
409
410     get_tcp_connections_for_ip "$_ip" | {
411         _killcount=0
412         _connections=""
413         _nl="
414 "
415         while read _dst _src; do
416             _destport="${_dst##*:}"
417             __oneway=$_oneway
418             case $_destport in
419                 # we only do one-way killtcp for CIFS
420                 139|445) __oneway=true ;;
421             esac
422
423             _connections="${_connections}${_nl}${_src} ${_dst}"
424             if ! $__oneway ; then
425                 _connections="${_connections}${_nl}${_dst} ${_src}"
426             fi
427
428             _killcount=$((_killcount + 1))
429         done
430
431         if [ $_killcount -eq 0 ] ; then
432             return
433         fi
434
435         echo "$_connections" | \
436                 "${CTDB_HELPER_BINDIR}/ctdb_killtcp" "$_iface" || {
437                 echo "Failed to kill TCP connections"
438                 return
439         }
440
441         _connections=$(get_tcp_connections_for_ip "$_ip")
442         if [ -z "$_connections" ] ; then
443                 _remaining=0
444         else
445                 _remaining=$(echo "$_connections" | wc -l)
446         fi
447
448         _actually_killed=$((_killcount - _remaining))
449
450         _t="${_actually_killed}/${_killcount}"
451         echo "Killed ${_t} TCP connections to released IP $_ip"
452
453         if [ -n "$_connections" ] ; then
454                 echo "Remaining connections:"
455                 echo "$_connections" | sed -e 's|^|  |'
456         fi
457     }
458 }
459
460 ##################################################################
461 # kill off the local end for any TCP connections with the given IP
462 ##################################################################
463 kill_tcp_connections_local_only ()
464 {
465     kill_tcp_connections "$@" "oneway"
466 }
467
468 ##################################################################
469 # tickle any TCP connections with the given IP
470 ##################################################################
471 tickle_tcp_connections ()
472 {
473     _ip="$1"
474
475     # Get connections, both directions
476     _conns=$(get_tcp_connections_for_ip "$_ip" | \
477                     awk '{ print $1, $2 ; print $2, $1 }')
478
479     echo "$_conns" | awk '{ print "Tickle TCP connection", $1, $2 }'
480     echo "$_conns" | ctdb tickle
481 }
482
483 get_tcp_connections_for_ip ()
484 {
485     _ip="$1"
486
487     ss -tn state established "src [$_ip]" | awk 'NR > 1 {print $3, $4}'
488 }
489
490 ########################################################
491
492 add_ip_to_iface ()
493 {
494     _iface=$1
495     _ip=$2
496     _maskbits=$3
497
498     # Ensure interface is up
499     ip link set "$_iface" up || \
500         die "Failed to bringup interface $_iface"
501
502     # Only need to define broadcast for IPv4
503     case "$_ip" in
504         *:*) _bcast=""      ;;
505         *)   _bcast="brd +" ;;
506     esac
507
508     # Intentionally unquoted multi-word value here
509     # shellcheck disable=SC2086
510     ip addr add "$_ip/$_maskbits" $_bcast dev "$_iface" || {
511         echo "Failed to add $_ip/$_maskbits on dev $_iface"
512         return 1
513     }
514
515     # Wait 5 seconds for IPv6 addresses to stop being tentative...
516     if [ -z "$_bcast" ] ; then
517         for _x in $(seq 1 10) ; do
518             ip addr show to "${_ip}/128" | grep -q "tentative" || break
519             sleep 0.5
520         done
521
522         # If the address was a duplicate then it won't be on the
523         # interface so flag an error.
524         _t=$(ip addr show to "${_ip}/128")
525         case "$_t" in
526             "")
527                 echo "Failed to add $_ip/$_maskbits on dev $_iface"
528                 return 1
529                 ;;
530             *tentative*|*dadfailed*)
531                 echo "Failed to add $_ip/$_maskbits on dev $_iface"
532                 ip addr del "$_ip/$_maskbits" dev "$_iface"
533                 return 1
534                 ;;
535         esac
536     fi
537 }
538
539 delete_ip_from_iface()
540 {
541     _iface=$1
542     _ip=$2
543     _maskbits=$3
544
545     # This could be set globally for all interfaces but it is probably
546     # better to avoid surprises, so limit it the interfaces where CTDB
547     # has public IP addresses.  There isn't anywhere else convenient
548     # to do this so just set it each time.  This is much cheaper than
549     # remembering and re-adding secondaries.
550     set_proc "sys/net/ipv4/conf/${_iface}/promote_secondaries" 1
551
552     ip addr del "$_ip/$_maskbits" dev "$_iface" || {
553         echo "Failed to del $_ip on dev $_iface"
554         return 1
555     }
556 }
557
558 # If the given IP is hosted then print 2 items: maskbits and iface
559 ip_maskbits_iface ()
560 {
561     _addr="$1"
562
563     case "$_addr" in
564         *:*) _bits=128 ;;
565         *)   _bits=32  ;;
566     esac
567     ip addr show to "${_addr}/${_bits}" 2>/dev/null | \
568         awk 'NR == 1 { iface = $2; sub(":$", "", iface) ;
569                        sub("@.*", "", iface) }
570              $1 ~ /inet/ { mask = $2; sub(".*/", "", mask);
571                            print mask, iface }'
572 }
573
574 drop_ip ()
575 {
576     _addr="${1%/*}"  # Remove optional maskbits
577
578     # Intentional word splitting here
579     # shellcheck disable=SC2046
580     set -- $(ip_maskbits_iface "$_addr")
581     if [ -n "$1" ] ; then
582         _maskbits="$1"
583         _iface="$2"
584         echo "Removing public address $_addr/$_maskbits from device $_iface"
585         delete_ip_from_iface "$_iface" "$_addr" "$_maskbits" >/dev/null 2>&1
586     fi
587 }
588
589 drop_all_public_ips ()
590 {
591         # _x is intentionally ignored
592         # shellcheck disable=SC2034
593         while read _ip _x ; do
594                 drop_ip "$_ip"
595         done <"${CTDB_PUBLIC_ADDRESSES:-${CTDB_BASE}/public_addresses}"
596 }
597
598 flush_route_cache ()
599 {
600     set_proc_maybe sys/net/ipv4/route/flush 1
601     set_proc_maybe sys/net/ipv6/route/flush 1
602 }
603
604 ########################################################
605 # Interface monitoring
606
607 # If the interface is a virtual one (e.g. VLAN) then get the
608 # underlying interface
609 interface_get_real ()
610 {
611     # Output of "ip link show <iface>"
612     _iface_info="$1"
613
614     # Extract the full interface description to see if it is a VLAN
615     _t=$(echo "$_iface_info" |
616                 awk 'NR == 1 { iface = $2; sub(":$", "", iface) ;
617                                print iface }')
618     case "$_t" in
619         *@*)
620             # VLAN: use the underlying interface, after the '@'
621             echo "${_t##*@}"
622             ;;
623         *)
624             # Not a regular VLAN.  For backward compatibility, assume
625             # there is some other sort of VLAN that doesn't have the
626             # '@' in the output and only use what is before a '.'.  If
627             # there is no '.' then this will be the whole interface
628             # name.
629             echo "${_t%%.*}"
630     esac
631 }
632
633 # Check whether an interface is operational
634 interface_monitor ()
635 {
636     _iface="$1"
637
638     _iface_info=$(ip link show "$_iface" 2>&1) || {
639         echo "ERROR: Monitored interface ${_iface} does not exist"
640         return 1
641     }
642
643
644     # If the interface is a virtual one (e.g. VLAN) then get the
645     # underlying interface.
646     _realiface=$(interface_get_real "$_iface_info")
647
648     if _bi=$(get_proc "net/bonding/${_realiface}" 2>/dev/null) ; then
649         # This is a bond: various monitoring strategies
650         echo "$_bi" | grep -q 'Currently Active Slave: None' && {
651             echo "ERROR: No active slaves for bond device ${_realiface}"
652             return 1
653         }
654         echo "$_bi" | grep -q '^MII Status: up' || {
655             echo "ERROR: public network interface ${_realiface} is down"
656             return 1
657         }
658         echo "$_bi" | grep -q '^Bonding Mode: IEEE 802.3ad Dynamic link aggregation' && {
659             # This works around a bug in the driver where the
660             # overall bond status can be up but none of the actual
661             # physical interfaces have a link.
662             echo "$_bi" | grep 'MII Status:' | tail -n +2 | grep -q '^MII Status: up' || {
663                 echo "ERROR: No active slaves for 802.ad bond device ${_realiface}"
664                 return 1
665             }
666         }
667
668         return 0
669     else
670         # Not a bond
671         case "$_iface" in
672             lo*)
673                 # loopback is always working
674                 return 0
675                 ;;
676             ib*)
677                 # we don't know how to test ib links
678                 return 0
679                 ;;
680             *)
681                 ethtool "$_iface" | grep -q 'Link detected: yes' || {
682                     # On some systems, this is not successful when a
683                     # cable is plugged but the interface has not been
684                     # brought up previously. Bring the interface up
685                     # and try again...
686                     ip link set "$_iface" up
687                     ethtool "$_iface" | grep -q 'Link detected: yes' || {
688                         echo "ERROR: No link on the public network interface ${_iface}"
689                         return 1
690                     }
691                 }
692                 return 0
693                 ;;
694         esac
695     fi
696 }
697
698 ########################################################
699 # Simple counters
700 _ctdb_counter_common () {
701     _service_name="${1:-${service_name:-${script_name}}}"
702     _counter_file="${CTDB_SCRIPT_VARDIR}/failcount/${_service_name}"
703     mkdir -p "${_counter_file%/*}" # dirname
704 }
705 # Some code passes an argument
706 # shellcheck disable=SC2120
707 ctdb_counter_init () {
708     _ctdb_counter_common "$1"
709
710     : >"$_counter_file"
711 }
712 ctdb_counter_incr () {
713     _ctdb_counter_common "$1"
714
715     # unary counting using newlines!
716     echo >>"$_counter_file"
717 }
718 ctdb_counter_get () {
719     _ctdb_counter_common "$1"
720     # unary counting!
721     stat -c "%s" "$_counter_file" 2>/dev/null || echo 0
722 }
723
724 ########################################################
725
726 ctdb_setup_service_state_dir ()
727 {
728         _s="${1:-${service_name}}"
729
730         _service_state_dir="${CTDB_SCRIPT_VARDIR}/service_state/${_s}"
731         mkdir -p "$_service_state_dir" ||
732                 die "Error creating state dir \"${_service_state_dir}\""
733
734         echo "$_service_state_dir"
735 }
736
737 ##################################################################
738 # Reconfigure a service on demand
739
740 _ctdb_service_reconfigure_common ()
741 {
742     _d="${CTDB_SCRIPT_VARDIR}/service_status/${service_name}"
743     mkdir -p "$_d"
744     _ctdb_service_reconfigure_flag="$_d/reconfigure"
745 }
746
747 ctdb_service_needs_reconfigure ()
748 {
749     _ctdb_service_reconfigure_common
750     [ -e "$_ctdb_service_reconfigure_flag" ]
751 }
752
753 ctdb_service_set_reconfigure ()
754 {
755     _ctdb_service_reconfigure_common
756     : >"$_ctdb_service_reconfigure_flag"
757 }
758
759 ctdb_service_unset_reconfigure ()
760 {
761     _ctdb_service_reconfigure_common
762     rm -f "$_ctdb_service_reconfigure_flag"
763 }
764
765 ctdb_service_reconfigure ()
766 {
767     echo "Reconfiguring service \"${service_name}\"..."
768     ctdb_service_unset_reconfigure
769     service_reconfigure || return $?
770     # Intentionally have this use $service_name as default
771     # shellcheck disable=SC2119
772     ctdb_counter_init
773 }
774
775 # Default service_reconfigure() function does nothing.
776 service_reconfigure ()
777 {
778     :
779 }
780
781 ##################################################################
782 # Does CTDB manage this service?
783
784 ctdb_compat_managed_service ()
785 {
786     if [ "$1" = "yes" -a "$2" = "$service_name" ] ; then
787         CTDB_MANAGED_SERVICES="$CTDB_MANAGED_SERVICES $2"
788     fi
789 }
790
791 is_ctdb_managed_service ()
792 {
793     assert_service_name
794
795     # $t is used just for readability and to allow better accurate
796     # matching via leading/trailing spaces
797     t=" $CTDB_MANAGED_SERVICES "
798
799     # Return 0 if "<space>$service_name<space>" appears in $t
800     if [ "${t#* ${service_name} }" != "${t}" ] ; then
801         return 0
802     fi
803
804     # If above didn't match then update $CTDB_MANAGED_SERVICES for
805     # backward compatibility and try again.
806     ctdb_compat_managed_service "$CTDB_MANAGES_VSFTPD"   "vsftpd"
807     ctdb_compat_managed_service "$CTDB_MANAGES_SAMBA"    "samba"
808     ctdb_compat_managed_service "$CTDB_MANAGES_WINBIND"  "winbind"
809     ctdb_compat_managed_service "$CTDB_MANAGES_HTTPD"    "apache2"
810     ctdb_compat_managed_service "$CTDB_MANAGES_HTTPD"    "httpd"
811     ctdb_compat_managed_service "$CTDB_MANAGES_ISCSI"    "iscsi"
812     ctdb_compat_managed_service "$CTDB_MANAGES_CLAMD"    "clamd"
813     ctdb_compat_managed_service "$CTDB_MANAGES_NFS"      "nfs"
814
815     t=" $CTDB_MANAGED_SERVICES "
816
817     # Return 0 if "<space>$service_name<space>" appears in $t
818     [ "${t#* ${service_name} }" != "${t}" ]
819 }
820
821 # Default service_start() and service_stop() functions.
822  
823 # These may be overridden in an eventscript.
824 service_start ()
825 {
826     service "$service_name" start
827 }
828
829 service_stop ()
830 {
831     service "$service_name" stop
832 }
833
834 ##################################################################
835
836 # This exists only for backward compatibility with 3rd party scripts
837 # that call it
838 ctdb_standard_event_handler ()
839 {
840     :
841 }
842
843 iptables_wrapper ()
844 {
845     _family="$1" ; shift
846     if [ "$_family" = "inet6" ] ; then
847         _iptables_cmd="ip6tables"
848     else
849         _iptables_cmd="iptables"
850     fi
851
852     # iptables doesn't like being re-entered, so flock-wrap it.
853     flock -w 30 "${CTDB_SCRIPT_VARDIR}/iptables.flock" "$_iptables_cmd" "$@"
854 }
855
856 # AIX (and perhaps others?) doesn't have mktemp
857 # type is commonly supported and more portable than which(1)
858 # shellcheck disable=SC2039
859 if ! type mktemp >/dev/null 2>&1 ; then
860     mktemp ()
861     {
862         _dir=false
863         if [ "$1" = "-d" ] ; then
864             _dir=true
865             shift
866         fi
867         _d="${TMPDIR:-/tmp}"
868         _hex10=$(dd if=/dev/urandom count=20 2>/dev/null | \
869             md5sum | \
870             sed -e 's@\(..........\).*@\1@')
871         _t="${_d}/tmp.${_hex10}"
872         (
873             umask 077
874             if $_dir ; then
875                 mkdir "$_t"
876             else
877                 : >"$_t"
878             fi
879         )
880         echo "$_t"
881     }
882 fi
883
884 ######################################################################
885 # NFS callout handling
886
887 nfs_callout_init ()
888 {
889         _state_dir="$1"
890
891         if [ -z "$CTDB_NFS_CALLOUT" ] ; then
892                 CTDB_NFS_CALLOUT="${CTDB_BASE}/nfs-linux-kernel-callout"
893         fi
894         # Always export, for statd callout
895         export CTDB_NFS_CALLOUT
896
897         # If the callout wants to use this then it must create it
898         export CTDB_NFS_CALLOUT_STATE_DIR="${_state_dir}/callout-state"
899
900         # Export, if set, for use by clustered NFS callouts
901         if [ -n "$CTDB_NFS_STATE_FS_TYPE" ] ; then
902                 export CTDB_NFS_STATE_FS_TYPE
903         fi
904         if [ -n "$CTDB_NFS_STATE_MNT" ] ; then
905                 export CTDB_NFS_STATE_MNT
906         fi
907
908         nfs_callout_cache="${_state_dir}/nfs_callout_cache"
909         nfs_callout_cache_callout="${nfs_callout_cache}/CTDB_NFS_CALLOUT"
910         nfs_callout_cache_ops="${nfs_callout_cache}/ops"
911 }
912
913 nfs_callout_register ()
914 {
915     mkdir -p "$nfs_callout_cache_ops"
916     rm -f "$nfs_callout_cache_ops"/*
917
918     echo "$CTDB_NFS_CALLOUT" >"$nfs_callout_cache_callout"
919
920     _t=$(eval "$CTDB_NFS_CALLOUT" "register")
921     if [ -n "$_t" ] ; then
922         echo "$_t" |
923             while IFS="" read _op ; do
924                 touch "${nfs_callout_cache_ops}/${_op}"
925             done
926     else
927         touch "${nfs_callout_cache_ops}/ALL"
928     fi
929 }
930
931 nfs_callout ()
932 {
933     # Re-run registration if $CTDB_NFS_CALLOUT has changed
934     _prev=""
935     if [ -r "$nfs_callout_cache_callout" ] ; then
936         read _prev <"$nfs_callout_cache_callout"
937     fi
938     if [ "$CTDB_NFS_CALLOUT" != "$_prev" ] ; then
939         nfs_callout_register
940     fi
941
942     # Run the operation if it is registered...
943     if [ -e "${nfs_callout_cache_ops}/${1}" ] || \
944            [ -e "${nfs_callout_cache_ops}/ALL" ]; then
945         eval "$CTDB_NFS_CALLOUT" "$@"
946     fi
947 }
948
949 ########################################################
950 # tickle handling
951 ########################################################
952
953 update_tickles ()
954 {
955         _port="$1"
956
957         tickledir="${CTDB_SCRIPT_VARDIR}/tickles"
958         mkdir -p "$tickledir"
959
960         # What public IPs do I hold?
961         _pnn=$(ctdb_get_pnn)
962         _ips=$($CTDB -X ip | awk -F'|' -v pnn="$_pnn" '$3 == pnn {print $2}')
963
964         # IPs and port as ss filters
965         _ip_filter=""
966         for _ip in $_ips ; do
967             _ip_filter="${_ip_filter}${_ip_filter:+ || }src [${_ip}]"
968         done
969         _port_filter="sport == :${_port}"
970
971         # Record connections to our public IPs in a temporary file.
972         # This temporary file is in CTDB's private state directory and
973         # $$ is used to avoid a very rare race involving CTDB's script
974         # debugging.  No security issue, nothing to see here...
975         _my_connections="${tickledir}/${_port}.connections.$$"
976         # Parentheses are needed around the filters for precedence but
977         # the parentheses can't be empty!
978         ss -tn state established \
979            "${_ip_filter:+( ${_ip_filter} )}" \
980            "${_port_filter:+( ${_port_filter} )}" |
981         awk 'NR > 1 {print $4, $3}' |
982         sort >"$_my_connections"
983
984         # Record our current tickles in a temporary file
985         _my_tickles="${tickledir}/${_port}.tickles.$$"
986         for _i in $_ips ; do
987                 $CTDB -X gettickles "$_i" "$_port" |
988                 awk -F'|' 'NR > 1 { printf "%s:%s %s:%s\n", $2, $3, $4, $5 }'
989         done |
990         sort >"$_my_tickles"
991
992         # Add tickles for connections that we haven't already got tickles for
993         comm -23 "$_my_connections" "$_my_tickles" | \
994                 $CTDB addtickle
995
996         # Remove tickles for connections that are no longer there
997         comm -13 "$_my_connections" "$_my_tickles" | \
998                 $CTDB deltickle
999
1000         rm -f "$_my_connections" "$_my_tickles"
1001
1002         # Remove stale files from killed scripts
1003         # Files can't have spaces in name, more portable than -print0/-0
1004         # shellcheck disable=SC2038
1005         (cd "$tickledir" && find . -type f -mmin +10 | xargs -r rm)
1006 }
1007
1008 ########################################################
1009 # load a site local config file
1010 ########################################################
1011
1012 [ -n "$CTDB_RC_LOCAL" -a -x "$CTDB_RC_LOCAL" ] && {
1013         . "$CTDB_RC_LOCAL"
1014 }
1015
1016 [ -x "${CTDB_BASE}/rc.local" ] && {
1017         . "${CTDB_BASE}/rc.local"
1018 }
1019
1020 [ -d "${CTDB_BASE}/rc.local.d" ] && {
1021         for i in "${CTDB_BASE}/rc.local.d"/* ; do
1022                 [ -x "$i" ] && . "$i"
1023         done
1024 }
1025
1026 script_name="${0##*/}"       # basename